%%% نام  قالب را تعیین می کند و همچنین بیان می کند که آخرین به روز رسانی  این قالب
%%% در چه زمانی بوده است. یک توصف مختصر هم از این بسته در اینجا امده است.
\ProvidesClass{Guilan-UserManual}
%%% تمام پارامترهای ورودی برای تنظیم متن را به کلاس زیر ارسال می‌کنیم
\DeclareOption*{\PassOptionsToClass{\CurrentOption}{memoir}}
\ProcessOptions 
\LoadClass[10pt,a4paper,oneside]{memoir}
%%% وارد کردن یکسری دستورات ابتدایی و بسته‌های مورد نیاز به استایل
\input{Guilan-BasicStyle}

%%% AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
%==================== تنظیمات بسته geometry
% تنظیمات مربوط به حاشیه صفحه
\geometry{top=2.8cm, bottom=3cm, left=2.2cm, right=2.3cm}
% برای تعیین اندازه صفحه ابتدا باید اندازه stock و page را با دو دستور زیر تعیین کنیم. برای کارهای ما که هر صفحه ی خروجی در یک صفحه پرینت می شود، این دو مقدار به صورت مساوی مقدار دهی می شود. 
% در دو دستور زیر ما مقادیر استاندارد برای کاغذ A4 را قرار داده ایم.
%\setlength{\headsep}{30pt}
%%\setstocksize{29.7cm}{21cm}
%%\settrimmedsize{29.7cm}{21cm}{*}
%\setlength{\trimtop}{0pt}
%\setlength{\trimedge}{\stockwidth}
%\addtolength{\trimedge}{-\paperwidth}
% در مرحله ی بعدی باید ابعادمتن در کاغذ را مشخص کنیم. 
%%\settypeblocksize{24.2cm}{16cm}{*}
% تعیین کننده حاشیه از بالا (آرگومان اول) و یا از پایین (آرگومان دوم) و یا نسبی (آرگومان سوم)
% دقت شود برای جلوگیری از ابهام تنها باید یکی از موارد فوق داده شود.
%%\setulmargins{2.5cm}{*}{*}
% به مانند دستور بالا، حاشیه از سمت چپ (آرگومان اول) و ...
%%\setlrmargins{2cm}{*}{*}
%\setmarginnotes{10pt}{10pt}{\onelineskip}
%%\setheadfoot{\onelineskip}{2\onelineskip}
%\setheaderspaces{*}{2\onelineskip}{*}
%%\checkandfixthelayout

%%==================== تنظیمات بسته subfig، ما دیگر از این بسته استفاده نمی‌کنیم. 
%%%\captionsetup[subfloat]{font=footnotesize,labelformat=empty}

%%==================== تنظیمات listing
%%  در این قسمت تمام ابزارهای مورد نیاز در نوشتن برنامه ها اورده شده 
%%  است. با استفاده از این ابزارهای می‌توان برنامه های مورد نیاز را در مستند جای داد.
\definecolor{listinggray}{gray}{.98}

\lstset{% general command to set parameter(s)
	% زبان برنامه نویسی که به طور پیش فرض انتخاب می شود.
	language=Java,
	% رنگ پیش فرض برای پیش زمینه
	backgroundcolor=\color{listinggray},
	%% میزان طول محیط listings را مشخص می کند، به صورت پیش فرض \textwidth است. 
	%linewidth=\textwidth ,
	%% نوع قالب دور محیط listings را تعیین می کند. 
	frameround=fttt,
	frame=trBL,
	%% is selected at the beginning of each listing. You could use \footnotesize,
	%% \small, \itshape, \ttfamily, or something like that. The last token of
	%% basic style must not read any following characters.
	basicstyle=\ttfamily, % print whole listing small
	%%   با این دستور استایل keyword ها را مشخص می کنیم. مثلا در این حالت گفته ایم که keyword ها را با رنگ آبی مشخص کند، و آن ها را bold‌کند. دقت کنید که keyword های زبان‌هایی که این بسته پشتیبانی می‌کند، 
	%% در این بسته تعریف شده است. مثلا در JAVA کلمه main به صورت پیش فرض تعریف شده است و در صورت وجود آن در کد شما آن را Latex آبی رنگ می‌کند. 
	keywordstyle=\color{blue}\bfseries,
	% underlined bold black keywords
	%identifierstyle=, % nothing happens
	%framexleftmargin=5mm, frame=shadowbox, rulesepcolor=\color{red}
	%% استایل String را در متن مشخص می کند. مثلا در این جا گفته شده است که رشته ها را با رنگ قرمز و به صورت ایتالیک نمایش بده.
	stringstyle=\ttfamily\color{red}, % typewriter type for strings
	%% نحوه استایل comment را مشخص می کند. دقت کنید که رنگ انتخاب شده نوعی رنگ سبز است، برای این که این رنگ شناخته شود می بایست دو بسته color و xcolor به صورتی که فراخوانی شده است، فراخوانی شود. 
	commentstyle=\color{LimeGreen},
	lineskip = .5pt,
	%% سه دستور بعدی نحوه نمایش شماره خطوط را مشخص می کند. 
	numberstyle=\footnotesize, 
	%% تعیین فاصله بین شماره خطوط و محیط listings
	numbersep=10pt,
	%% محل قرارگیری شماره خطوط
	numbers=left,
	%% تعیین محل قرارگیری caption محیط. بطور پیش فرض در بالای محیط است که به پایین محیط تغییر داده شده است. 
	captionpos=b, 
	%% توسط breakline می توانید خاصیت شکسته شدن خطوط بلند را در محیط listings فعال و یا غیرفعال کنید.
	%% activates or deactivates automatic line breaking of long lines.
	breaklines=true,
	%% باعث می شود که فاصله های بین رشته های نمایان شود.
	%% lets blank spaces in strings appear  or as blank spaces
	showstringspaces=true
}% 

%% البته شما می توانید این موارد پیش فرض را به ازای هر کد تغییر دهید. به عنوان مثال، ما یک کد در پوشه Code در شاخه فعلی قرار دادیم، می خواهیم آن را وارد متن کنیم، کافی است که خطوط زیر را در محل مناسبی که می خواهیم کد را قرار دهیم وارد کنیم. در این مثال یک فایل کد JAVA به نام myCode.java را می خواهیم وارد کنیم. 
%%\begin{latin}
%%\lstinputlisting[breaklines=true,numbers=left,language=Java, basicstyle=\ttfamily, numberstyle=\footnotesize, numbersep=10pt, captionpos=b, frame=single, breakatwhitespace=false]{Code/myCode.java}
%%\end{latin}

%%==================== تنظیمات hyperref

%%% برای وارد کردن کلمه (بخش) در فهرست مطالب بسته hyperref برای حالت فارسی یک مشکل دارد. بدین منظور این 
%%% مشکل را به صورت دستی حل شده است. برای این که رنگ keywordstyle که تعیین کننده رنگ کل قسمت فهرست مطالب
%%% نیز هست یکسان در آید یک پارامتر رنگ برای keywordstyle این جا تعریف می‌کنیم، و سپس از آن هم در تنظمیات hypperref 
%%% و هم در اون کدهایی که به صورت دستی وارد شده است، استفاده می‌شود. 
\newcommand{\keywordstyleColor}{blue}


%% در این قسمت تنظیمات بسته hyperref را قرار می دهیم.
%% این تنظیمات شامل موارد زیر است.
\hypersetup{
%% موقعی که فایل پی دی اف خروجی را باز می کنید صفحه به صورت عریض و بزرگ باز می شود.
	pdfmenubar=false, pdfstartview=FitH, 
	%% در قسمت مراجع شماره صفحه ای که به آن مرجع ارجاع داده است را وارد می کند،
	%% مواردی که برای فعال سازی این که شماره اشکال را به صورت ارجاعی نشان دهد
	%pagebackref =true,hyperfigures=true,
	%% به جای استفاده از مربع قرمز دور موارد ارجاعی از لینک های رنگی استفاده کند.
	colorlinks=true, 
	%% رنگ برخی از لینک ها در زیر تعریف شده است. 
	linkcolor=\keywordstyleColor, anchorcolor=green, citecolor=magenta, urlcolor=cyan, filecolor=magenta, pdftoolbar=true
	%bookmarksopen = true,
	%bookmarksopenlevel = 1
	%%% اگر این option را true‌ بکنیم، آن‌گاه در کنار bookmark شماره فصل و بخش و زیربخش نیز می آید. مثلا می‌نویسد: ۱.۲ طراحی شبکه
	%bookmarksnumbered = true
}%

%%==================== تنظیمات tikz
\usetikzlibrary{mindmap,backgrounds,shadows}

%%==================== تنظیمات graphicx
% برای اضافه کردن تصاویر به متن این امکان وجود دارد که تصاویر را در پوشه‌های
% متفاوت قرار داد. با این کار از زیاد شدن پرونده‌ها در مسیر مستند جلوگیری می
% شود. علاوه بر این دسته‌ای از تصاویر وجود دارد که بین همه مستندها مشترک است
% برای نمونه نماد پژوهشکده که بین همه مشترک است.  از این رو تعداد مسیر به عنوان
% مسیرهای پیش فرض برای جستجوی تصاویر تعیین شده است.
\graphicspath{{./}{./images/}}

%%==================== تنظیمات  بسته caption
%%% تنظیمات مربوط به زیرنویس اشکال و جداول، این تنظیمات را تنها زمانی می‌توانید انجام دهید که بسته caption را فراخوانی کرده‌باشید. ما دیگر از این بسته در هنگامی که از memoir استفاده می‌کنیم، استفاده نمی‌کنیم. 
%%%\captionsetup{margin=10pt,font=small,labelfont=bf,labelformat=parens,textfont={small},skip=9pt}

%% تنظیم caption جداول و اشکال و ... توسط دستورات memoir
\captionnamefont{\small}
\captiontitlefont{\small}
%\captionstyle{}
%\captionwidth{\linewidth}
%\normalcaptionwidth
%\normalcaption
%\captiondelim{: }

%%==================== تنظیمات algorithm و algorithmic
\floatname{algorithm}{الگوریتم}

%%==================== تنظیمات مربوط به ایجاد watermarking
%% درصد روشنایی watermark
\SetWatermarkLightness{.94}
%% زاویه متن Watermark
\SetWatermarkAngle{45}
%% اندازه watermark
\SetWatermarkScale{1.5}

\let\oldSetWatermarkText\SetWatermarkText
%% اگر بخواهید watermark شما یک رنگ دیگر داشته باشد، این دو خط را فعال کنید و رنگ مورد نظر خود را انتخاب کنید
%\definecolor{orange}{RGB}{229,252,219} 
%\renewcommand{\SetWatermarkText}[1]{\oldSetWatermarkText{\textcolor{orange}{#1}}}

\DeclareDocumentCommand{\SetWatermarkText}{m g}{
	\oldSetWatermarkText{#1}
	\IfValueTF{#2}{
		\SetWatermarkLightness{#2}
	}{%%
		\SetWatermarkLightness{.97}
	}%%
}%

%%% OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO

%%% تنظیم فونت
%%%% نکته اول: اندازه فونت.

%% نحوه تنظیم اندازه فونت ها، برگرفته از:
%% http://www.parsilatex.com/forum/SMF/index.php?topic=1349.0
%%اول باید دقت کنید که برای مثال فونت B Nazanin (مثل اکثر فونت‌های فارسی) از فونت‌هایی است که نسبت 10:12 داره (البته همه این طور نیستند فونت XB Zar نسبتش 10:10 و فونت Adobe Arabic نسبتش 10:14). 
%%نسبت 10:12 یعنی اینکه سایز ۱۲ این فونت معادل سایز 10pt استاندارد PostScript می‌باشد... که در واقع کوچکترین سایز استاندارد نوشتارهای بلند رسمی است.
%%سه سایز‌ استاندارد برای فن نوشتار‌های رسمی وجود دارد 
%%۱- سایز 10pt که سایز کوچک نامیده شده (که فونت‌سایز پیشفرض تک می‌باشد.(
%%۲- سایز 11pt که سایز متوسط نامیده می‌شود  
%%۳- سایز 12pt که سایز بزرگ محصوب می‌شود
%%در فونت‌های 10:12 
%%اندازه ۱۲ همان 10pt است
%%اندازه ۱۳ همان 11pt است  (در واقع ۱۳.۲ معادل 11pt  است)
%%اندازه ۱۴ همان 12pt است (در واقع ۱۴.۴ معادل 12pt است)
%%اگر می‌خواهید اندازه پایه‌ی نوشته‌های عادی 14 شود (یعنی متن عادی به اندازه 14 شود و سایر نوشته‌ها به نسبت آن تغییر کنند) از آنجا که اندازه ۱4 همان 12pt است باید دو کار زیر را انجام دهیم:
%% عمل اول: در دستور  loadClass عدد 12pt را بگذارید.
%% \LoadClass[12pt]{...}
%% عمل دوم: به هنگام بارگزاری کردن فونت‌های 10:12 باید از پارامتر Scale=1.2 در دستور انتخاب فونت استفاده کنید. 
%%مثلا در این جا به صورت زیر باید نوشت:
%%\settextfont[Scale=1.3]{B Nazanin} 
%%\settextfont[Scale=1.2]{XB Niloofar}
%% که اندازه می شود 1.2*12 که می آید 14.4 اگر 1.2 را کمتر کنیم می توانیم دقیقا اندازه 14 را بدست آوریم. 
%% تنظیمات پش فرض برای قلم و رنگ آن. در این قسمت نوع نوشتن متن و سرایندها تعیین شده است.


%%%% نکته دوم: نوع فونت فارسی یا انگلیسی بودن آن. 
%% در نرم افزار word وقتی شما از یک فونت به عنوان نمونه B Nazanin استفاده می کنید، word در هنگام مواجه با کلمات انگلیسی، این کلمات را به
%% یک فونت پیش فرض تبدیل می کند.چرا که اغلب فونت هایی که ما با آن ها کار می کنیم، تنها می توانند زبان فارسی و یا انگلیسی را پشتیبانی کنند. مثلا B Nazanin فقط برای پشتیبانی از زبان فارسی است و نه برای انگلیسی، لذا Word چنین رفتاری را  بدون این که شما متوجه شوید انجام می دهد. اما در LATEX این گونه نیست. برای حل این مشکل دو راه حل دارید:

%% راه حل اول: از فونت های سری XB مثل XB Niloofar .و... استفاده کنید. برای این موضوع به قسمت قلم‌ها و حروف سایت پارسی لاتک مراجعه کنید در ضمن در مرکز دانلود سایت این فونت ها قرار داده شده است. فونت های سری XB، XM، XW هم می توانند زبان فارسی را پشتیبانی کنند و هم زبان انگلیسی را. 

%% راه حل دوم: در کل در xepersian اگر از فونت هایی مثل سری XB که هم فارسی و هم انگلیسی را پشتیبانی می کنند استفاده نکنید، می بایست عبارات انگلیسی در متن فارسی را در داخل یک \lr{} قرار دهید تا فهمیده شود که این عبارت باید با فونت انگلیسی نوشته شود، و توسط دستور \setlatintextfont نیز یک فونت انگلیسی تعریف کنید. مانند آن چه که در ادامه آمده است. 

%% در کل به نظر من راه حل دوم بهتر است. 
\renewcommand{\defaultFont}{
	%%%  با دستور زیر می توانید فونتی مخصوص عبارات فارسی تعیین کنید:
	\settextfont[Scale=1.3]{B Nazanin} 
	%%\settextfont[Scale=1.2]{XB Niloofar}
	%%% شما با دستور زیر بعد از فراخوانی بسته xepersian می توانید فونت انگلیسی را تعیین کنید
	%%% دقت کنید که عبارات انگلیسی شما باید در دستور \lr{} قرار گیرد تا xepersian بتواند بفمهد که این عبارات انگلیسی است
	%%\setlatintextfont[Scale=1]{Times New Roman}
	\setlatintextfont[Scale=1.1]{Linux Libertine}
	%% % تعریف برای فونت اعداد و ارقام
	%\setdigitfont[Scale=1.1]{XB Zar}
}%

\defaultFont

%% توسط دستورات defpersianfont و deflatinfont به ترتیب می توان یکسری فونت فارسی و انگلیسی دیگر تعریف کرد که در جاهای دیگر متن بتوان از آن استفاده کرد. برای استفاده کافی است که عبارتی که می خواهیم فونت آن عوض شود را به صورت زیر به عنوان نمونه بنویسیم.
%% \versionfont{این یک مثال است. }

%% تعریف یکسری فونت برای قسمت عنوان پروژه و ما بقی قسمت ها فونت قسمت "موسسه " در صفحه عنوان

\defpersianfont\pejoheshfont[Scale=1.4]{Titr Bold}
%%فونت اسم گروه XB Titre
\defpersianfont\groupfont[Scale=1.4]{Zar}
%%% فونت عنوان گزارش
\defpersianfont\titlefont[Scale=2.4]{Titr Bold}
%% فونت نسخه گزارش
\defpersianfont\versionfont[Scale=1.6]{Mitra}
\defpersianfont\payanFont[Scale=1.8]{XB Yas}
\defpersianfont\nastaliq[Scale=2]{IranNastaliq}
\defpersianfont\farsifontshafigh[Scale=1.3]{Adobe Arabic}
\defpersianfont\titrt[Scale=1]{XB Titre}
\defpersianfont\traffict[Scale=1]{B Traffic}
\defpersianfont\farsifontsayeh[Scale=1.5]{XB Kayhan Sayeh}
\defpersianfont\titlefont[Scale=2.4]{Titr}
\defpersianfont\godFont[Scale=1]{B Nazanin}
\defpersianfont\titleFontEn[Scale=1]{Traffic}
%% فونت‌های مورد نیاز برای صفحه شروع 
\defpersianfont\tablefont[Scale=.8]{XM Traffic}
\deflatinfont\tableFontEn[Scale=.9]{Adobe Arabic}
%%  با استفاده از این دستور می‌توان فونت و فارسی و یا انگلیسی بودن اعداد در فرمول‌ها را به حالت اولیه (یعنی پیش‌فرض لاتک) برگرداند.
\DefaultMathsDigits

%% نحوه تغییر اندازه فونت عبارات ریاضی و فرمول‌ها. این کار توسط دستور زیر انجام می‌شود. 
%%\DeclareMathSizes{textsize}{mathsize}{scriptsize}{scriptscriptsize}
%% گزینه اول: این برای چه دسته فونتی است. پیش فرض استایل ما فونت 10pt است. 
%% گزینه دوم: اندازه فونت توابع و موجودات ریاضی درون متن.
%% گزینه سوم: برای اسکریپت ها، اندازه زیرنویس و بالانویس.
%% گزینه چهارم: برای زیرنویس زیرنویس.

%% در دستورات زیر ما برای سه حالت، اندازه‌های مورد نظر را تعریف کرده ایم. 
%%\DeclareMathSizes{10}{11}{9}{8}   % For size 10 text
%%\DeclareMathSizes{11}{12}{11}{10}   % For size 11 text
%%\DeclareMathSizes{12}{13}{12}{11}  % For size 12 text

%% OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO

%% فایل  Environments  در برگیرنده تعریف یکسری محیط نوین است. 
\input{Guilan-Environments}

%% فایل  Environments  در برگیرنده تعریف یکسری استایل برای فصل‌ها است. 
\input{Guilan-ChapterStyle}

%%% تعریف یکسری استایل برای صفحه شروع 
\input{Guilan-titleStyle}


%% OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO

%%% یکسری تنظیمات کلی در متن اصلی

%%% تنظیم فاصله خطوط در متن اصلی
\setlength{\baselineskipVar}{1cm}
%%% تنظیم فاصله خطوط در فهرست‌ها
\setlength{\listlineskipVar}{0.9cm}
%%%============================ پاورقی
%%% تنظیم‌های مربوط به پاورقی: فاصله پاورقی با متن + فاصله بین خطوط در پاورقی
\setlength{\footnotesep}{0.5cm}
\setlength{\skip\footins}{2cm}

%%%\part{part}	     				-1	not in letters
%%%\chapter{chapter}		 	0	only books and reports
%%%\section{section}		 	1	not in letters
%%%\subsection{subsection}		2	not in letters
%%%\subsubsection{subsubsection}	3	not in letters
%%%\paragraph{paragraph}		4	not in letters
%%%\subparagraph{subparagraph}	5	not in letters

\makeatletter
\renewcommand*\l@part[2]{
  \ifnum \c@tocdepth >-2\relax
    \addpenalty{-\@highpenalty}
    \addvspace{2.25em \@plus\p@}
    \setlength\@tempdima{2em}
    \begingroup
      \parindent \z@ \if@RTL\leftskip\else\rightskip\fi \@pnumwidth
      \parfillskip -\@pnumwidth
      {\leavevmode
       \large \bfseries\textcolor{\keywordstyleColor}{بخش} #1
       \hfil \hb@xt@\@pnumwidth{\hss #2}}\par
       \nobreak
         \global\@nobreaktrue
         \everypar{\global\@nobreakfalse\everypar{}}
    \endgroup
  \fi}
\makeatother

%%% این دستور تعیین می‌کند که در متن تا چه عمقی شماره‌گذاری انجام شود. 
\setcounter{secnumdepth}{3}

%%% باز تعریف محیط شکل
\makeatletter
\renewenvironment{figure}[1][]{
	 \ifthenelse{\equal{#1}{}}{
		   \@float{figure}
	 }{%%
		   \@float{figure}[#1]
	 }%%
	 \centering
}{%
	 \end@float
}%
\makeatother

%%============================ تنظیمات مربوط به فونت و اندازه جداول
%% تنظیمات مربوط به جدول و فونت آن
%%\newcolumntype{I}{!{\vrule width 1.5pt}}
%%\newlength\savedwidth
%%\newcommand\whline
%%{\noalign{\global\savedwidth\arrayrulewidth\global\arrayrulewidth 1.5pt}\hline\noalign{\global\arrayrulewidth\savedwidth}}
%%
%%\newcolumntype{R}{>{\centering\tableFont}c}
%%\newcolumntype{T}{>{\centering\arraybackslash\tableFont}p{.4\linewidth}}

%% بازنویسی محیط جدول
%\let\oldtable\table
%\let\endoldtable\endtable
\makeatletter
\renewenvironment{table}[1][]{
	\ifthenelse{\equal{#1}{}}{\@float{table}}{\@float{table}[#1]}
	\centering
}{%
	\end@float
}%
\makeatother
	
	% بازنویسی محیط tabular به منظور تنظیم فونت‌های جدول
\let\oldtabular\tabular
\let\endoldtabular\endtabular
\renewenvironment{tabular}{
	\bgroup
	\settextfont[Scale=.8]{XM Traffic}
	\setlatintextfont[Scale=.9]{Linux Libertine}
	\oldtabular
}{%
	\endoldtabular 
	\egroup
}%

% تنظیم کننده فاصله بین خطوط (ردیف‌ها) در یک جدول
\renewcommand{\arraystretch}{1.2}
% تنظیم کننده ضخامت خطوط جدول
%\renewcommand{\arrayrulewidth}{.55pt}
% تنظیم فاصله بین خطوط دو خطه (||) و یا (حالت افقی ||)
%\renewcommand{\doublerulesep}{1pt}

%% OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO

%%% دستوری برای سیاه و سفید کردن متن برای گرفتن پرینت. در این دستور در اولین گام رنگ تمامی ارجاعات که توسط hyperref فعال می‌شوند،
%%% سیاه می‌شود. 
\newcommand{\printver}{
	\renewcommand{\keywordstyleColor}{black}
	\hypersetup{linkcolor=black, anchorcolor=black, citecolor=black, urlcolor=black, filecolor=black, pdftoolbar=true}
}%


%% باز تعریف محیط document، هر دستوری که می خواهید در ابتدای برنامه اجرا شود را در این قسمت بنویسید.

%% بازنویسی محیط \begin{document}
\let\olddocument\document
\let\endolddocument\enddocument

\makeatletter
\renewenvironment{document}{
	\olddocument
	%% تنظیم استایل سرفصل
%	\chapterstyle{BlueBox}
	\pagestyle{plain}
	%% تنظیم فاصله بین خطوط با دستور \baselineskip
	\baselineskip = \baselineskipVar
	\pagenumbering{arabic}
	\SetWatermarkText{}
}{%
	\endolddocument
}%
\makeatother

%%% OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
%%  برگه نخست در مستند را ایجاد می‌کند. در این برگه تنها نام پروردگار
%% ذکر می‌شود. برای ایجاد نام پرودگار یک تصویر استفاده می‌شود به نام god.ps
%% که باید در پوشه image کنار پرونده اصلی مستند قرار گرفته شده باشد.
\DeclareDocumentCommand{\Godpage}{g g}{	
	\thispagestyle{empty}
	\begin{center}
	\IfValueTF{#1}{
		\IfValueTF{#2}{
			\includegraphics[width=#2\textwidth]{#1}
		}{%%%
			\includegraphics[width=.3\textwidth]{#1}
		}%%%
	}{%%
		\IfValueTF{#2}{
			\includegraphics[width=#2\textwidth]{god}
		}{%%%
			\includegraphics[width=.7\textwidth]{god}
		}%%%
	}%%
	\end{center}
	\newpage
}%

%% محیطی برای قرار دادن abstract در گزارش و یا  در ابتدای هر فصل. در صورت استفاده از این محیط، متون داخل آن با فونتی متفاوت با فونت متن نوشته شده و در ابتدای متن نیز یک کلمه چکیده اضافه می شود. 
\renewenvironment{abstract}{%
	\section*{چکیده}
	\settextfont[Scale=1.2]{Adobe Arabic} 
	\setlatintextfont[Scale=1]{Times New Roman}
	\baselineskip = 1.5cm
}{%
	\\*[8pt]
}%


%%% این دستور تعیین می‌کند که چه تا چه عمقی شماره‌گذاری شود. در خود متن نه در فهرست مطالب دقت کنید که برای تعیین این که در فهرست مطالب تا چه عمقی شماره گذاری صورت بگیرد باید از دستور
%%% \setcounter{tocdepth}{....}
%%% استفاده کرد که در ادامه می آید. 

\setcounter{tocdepth}{4}
%%%  تنظیمات مربوط به فهرست مطالب، بازنویسی محیط فهرست مطالب برای تعیین فاصله خطوط، قرار دادن در bookmark ها
\let\Oldtableofcontents\tableofcontents
\renewcommand{\tableofcontents}{
	\pagenumbering{harfi}
	\baselineskip = \listlineskipVar
%	\pdfbookmark[0]{ فهرست مطالب}{title}
	\Oldtableofcontents\clearpage
	\baselineskip = \baselineskipVar
	\savepagenumber
	\pagenumbering{arabic}
}%

% با این دستور در فهرست مطالب در هنگام آوردن شماره و عنوان فصل در ابتدای آن یک کلمه فصل می گذارد یعنی مثلا می نویسد: (فصل اول: مقدمه ای بر شبکه ..................... ۱)
\renewcommand*{\cftchaptername}{
فصل
\space}%


%%% OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO


%%=========================== تنظمیات محیط فهرست اشکال

%% در دستورات زیر محیط فهرست اشکال باز تعریف شده و اولا این محیط به bookmark اضافه شده و ثانیا مشکل صفحات اضافی حل شده است. ثالثا فاصله خطوط برای زیبایی در این 
%% محیط اندکی کم شده است، ولی دوباره بعد از آوردن این محیط به حالت اولیه برگشته است. در ضمن از شماره گذاری حرفی برای این محیط استفاده شده است. 
\let\Oldlistoffigures\listoffigures
\renewcommand{\listoffigures}{
	\pagenumbering{harfi}
	\restorepagenumber
	\baselineskip = \listlineskipVar
%	\pdfbookmark[0]{ فهرست تصاویر}{titleFig}
	\Oldlistoffigures
	\clearpage
	\baselineskip = \baselineskipVar
	\savepagenumber
	\pagenumbering{arabic}
}%

%%% OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO

%% در دستورات زیر محیط فهرست جداول باز تعریف شده و اولا این محیط به bookmark اضافه شده و ثانیا مشکل صفحات اضافی حل شده است. ثالثا فاصله خطوط برای زیبایی در این 
%% محیط اندکی کم شده است، ولی دوباره بعد از آوردن این محیط به حالت اولیه برگشته است. در ضمن از شماره گذاری حرفی برای این محیط استفاده شده است. 
\let\Oldlistoftables\listoftables
\renewcommand{\listoftables}{
	\pagenumbering{harfi}
	\restorepagenumber
	\baselineskip = \listlineskipVar
%	\pdfbookmark[0]{فهرست جداول}{titleTab}
	\Oldlistoftables\clearpage
	\baselineskip = \baselineskipVar
	\savepagenumber
	\pagenumbering{arabic}
}%

%%% OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO

\input{Guilan-Gloss}

%%============================ دستور برای قرار دادن فهرست اختصارات 
\newcommand{\printabbreviation}{
	\clearpage
	\phantomsection
	\let\appendix\relax
	\baselineskip=.75cm
	\addcontentsline{toc}{chapter}{فهرست اختصارات}
	\glossarystyle{mylistAbbr}
	\Oldprintglossary[type=abrr]
	\clearpage
	\baselineskip = \baselineskipVar
}%

\newcommand{\printnotation}{
	\clearpage
	\phantomsection
	\let\appendix\relax
	\baselineskip = \listlineskipVar
	\addcontentsline{toc}{chapter}{فهرست نمادها}
	\glossarystyle{mylistNotation}
	\Oldprintglossary[type=symbols]
	\clearpage
	\baselineskip = \baselineskipVar
}%

\let\Oldbibliography\bibliography
\renewcommand{\bibliography}[1]{
	\let\appendix\relax
	\baselineskip=.5cm
	\renewcommand{\bibname}{منابع و مآخذ}
	\clearpage
	\phantomsection
	\bibliographystyle{ieeetr-fa}
	\Oldbibliography{#1}
}%
%% در این جا محیط هر دو واژه نامه را باز تعریف کرده ایم، تا اولا مشکل قرار دادن صفحه اضافی را حل کنیم، ثانیا عنوان واژه نامه ها را با دستور addcontentlist وارد فهرست مطالب کرده ایم.

\renewcommand{\printglossary}{
	\let\appendix\relax
	\baselineskip=.75cm
	\clearpage
	\phantomsection
	\twocolumn{}
	\addcontentsline{toc}{chapter}{واژه نامه انگلیسی به فارسی}
	\glossarystyle{mylistEn}
	\Oldprintglossary[type=english]
	
	\clearpage
	\phantomsection
	\addcontentsline{toc}{chapter}{واژه نامه فارسی به انگلیسی}
	\glossarystyle{mylistFa}
	\Oldprintglossary[type=persian]
	\onecolumn{}
	\baselineskip = \baselineskipVar
}%

%%% OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO

%%===================== قرار دادن نمایه کلمات به عنوان آخرین قسمت گزارش
%% در دستورات زیر محیط نمایه را باز تعریف کرده ایم، در این باز تعریف فونت این محیط را به یکی از فونت های سری XB بردیم تا مشکلی از بابت نوشتن فارسی و انگلیسی با یک فونت به وجود نیاید. 
\let\Oldprintindex\printindex
\renewcommand{\printindex}{
	\let\appendix\relax
	\baselineskip=.75cm
	\clearpage
	\phantomsection
	\settextfont[Scale=1.2]{XB Niloofar}
	\Oldprintindex
	\clearpage
	\baselineskip = \baselineskipVar
}%

%%% OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO

%%============================ تنظیمات مربوط به بسته pagenote 
\notepageref
%% تنظیم عنوان فصلی که قرار است pagenote ها در آن جمع شود.
\renewcommand*{\notesname}{نکات}
%% تنظیم این که pagenote  ها در یک فصل جمع شوند.
\renewcommand*{\notedivision}{\chapter{\notesname}}
\renewcommand*{\pagerefname}{صفحه}
\makepagenote
\continuousnotenums

\newcommand{\handNote}{\item[\Huge\color{red}\ding{45}]}
%% در این جا ما محیط pagenote را باز تعریف کرده ایم. با این کار هر وقت که در متن از pagenote استفاده کنیم در یک محیط itemize با یک item یک علامت دست در حال نوشتن با رنگ قرمز 
%% می گذارد و سپس می نویسد نکته ۳: و سپس خود نکته را با رنگی غیر از رنگ سیاه برای تمایز با متن می نویسد. 
\let\Oldpagenote\pagenote
\renewcommand{\pagenote}[1]{
	\begin{itemize}
	\handNote
	\textcolor{red}{\textbf{نکته 
	\Oldpagenote{#1}:}}\\
	\textcolor{Brown}{#1}
	\end{itemize}
}%

\renewcommand*{\notenumintext}[1]{#1}


% OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO

























